// Form1.h

#pragma once

namespace TrafficLightDemo
{
	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
  using namespace System::Collections::Generic;

	/// <summary>
	/// Zusammenfassung fr Form1
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1() : m_setTrafficLightsToCycle(gcnew SortedSet<String ^>)
		{
			InitializeComponent();
			//
			//TODO: Konstruktorcode hier hinzufgen.
			//
		}

	protected:
		/// <summary>
		/// Verwendete Ressourcen bereinigen.
		/// </summary>
		~Form1()
		{
      tmrCycleState->Stop();

			if (components)
			{
				delete components;
			}
		}

  private:
    SortedSet<String ^> ^m_setTrafficLightsToCycle;  // Contains just the names, not the actual TrafficLight objects

  private: System::Windows::Forms::ComboBox^  cbxState;
  private: System::Windows::Forms::Label^  label1;
  private: System::Windows::Forms::ComboBox^  cbxLight;
  private: System::Windows::Forms::Label^  label2;
  private: System::Windows::Forms::CheckBox^  chkCycle;
  private: System::Windows::Forms::Timer^  tmrCycleState;
  private: System::ComponentModel::IContainer^  components;

	private:
		/// <summary>
		/// Erforderliche Designervariable.
		/// </summary>


#pragma region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung.
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		void InitializeComponent(void)
		{
      this->components = (gcnew System::ComponentModel::Container());
      System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(Form1::typeid));
      this->cbxState = (gcnew System::Windows::Forms::ComboBox());
      this->label1 = (gcnew System::Windows::Forms::Label());
      this->cbxLight = (gcnew System::Windows::Forms::ComboBox());
      this->label2 = (gcnew System::Windows::Forms::Label());
      this->chkCycle = (gcnew System::Windows::Forms::CheckBox());
      this->tmrCycleState = (gcnew System::Windows::Forms::Timer(this->components));
      this->SuspendLayout();
      // 
      // cbxState
      // 
      this->cbxState->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
      this->cbxState->FormattingEnabled = true;
      this->cbxState->Items->AddRange(gcnew cli::array< System::Object^  >(6) {L"Dark", L"Red", L"RedYellow", L"Yellow", L"GreenYellow", 
        L"Green"});
      this->cbxState->Location = System::Drawing::Point(80, 157);
      this->cbxState->Name = L"cbxState";
      this->cbxState->Size = System::Drawing::Size(121, 21);
      this->cbxState->TabIndex = 3;
      this->cbxState->SelectedIndexChanged += gcnew System::EventHandler(this, &Form1::cbxState_SelectedIndexChanged);
      // 
      // label1
      // 
      this->label1->AutoSize = true;
      this->label1->Location = System::Drawing::Point(12, 160);
      this->label1->Name = L"label1";
      this->label1->Size = System::Drawing::Size(35, 13);
      this->label1->TabIndex = 2;
      this->label1->Text = L"&State:";
      // 
      // cbxLight
      // 
      this->cbxLight->FormattingEnabled = true;
      this->cbxLight->Location = System::Drawing::Point(80, 130);
      this->cbxLight->Name = L"cbxLight";
      this->cbxLight->Size = System::Drawing::Size(121, 21);
      this->cbxLight->TabIndex = 1;
      this->cbxLight->SelectedIndexChanged += gcnew System::EventHandler(this, &Form1::cbxLight_SelectedIndexChanged);
      // 
      // label2
      // 
      this->label2->AutoSize = true;
      this->label2->Location = System::Drawing::Point(12, 133);
      this->label2->Name = L"label2";
      this->label2->Size = System::Drawing::Size(62, 13);
      this->label2->TabIndex = 0;
      this->label2->Text = L"Traffic &light:";
      // 
      // chkCycle
      // 
      this->chkCycle->AutoSize = true;
      this->chkCycle->Location = System::Drawing::Point(15, 184);
      this->chkCycle->Name = L"chkCycle";
      this->chkCycle->Size = System::Drawing::Size(102, 17);
      this->chkCycle->TabIndex = 4;
      this->chkCycle->Text = L"Auto-&cycle state";
      this->chkCycle->UseVisualStyleBackColor = true;
      this->chkCycle->CheckedChanged += gcnew System::EventHandler(this, &Form1::chkCycle_CheckedChanged);
      // 
      // tmrCycleState
      // 
      this->tmrCycleState->Enabled = true;
      this->tmrCycleState->Interval = 3000;
      this->tmrCycleState->Tick += gcnew System::EventHandler(this, &Form1::tmrCycleState_Tick);
      // 
      // Form1
      // 
      this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
      this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
      this->ClientSize = System::Drawing::Size(222, 213);
      this->Controls->Add(this->chkCycle);
      this->Controls->Add(this->label2);
      this->Controls->Add(this->cbxLight);
      this->Controls->Add(this->label1);
      this->Controls->Add(this->cbxState);
      this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedSingle;
      this->Icon = (cli::safe_cast<System::Drawing::Icon^  >(resources->GetObject(L"$this.Icon")));
      this->MaximizeBox = false;
      this->Name = L"Form1";
      this->Text = L"Traffic Light Demo";
      this->Load += gcnew System::EventHandler(this, &Form1::Form1_Load);
      this->ResumeLayout(false);
      this->PerformLayout();

    }
#pragma endregion

    // Event handlers

  private:
    System::Void Form1_Load(System::Object^  sender, System::EventArgs^  e);
    System::Void cbxState_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e);
    System::Void cbxLight_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e);
    void TrafficLightClickHandler(Object ^sender, EventArgs ^e);  // Not created by the IDE
    System::Void chkCycle_CheckedChanged(System::Object^  sender, System::EventArgs^  e);
    System::Void tmrCycleState_Tick(System::Object^  sender, System::EventArgs^  e);
};
}

